title=NEWS for Ruby 2.3.0


このドキュメントは前回リリース以降のバグ修正を除くユーザーに影響のある機能の変更のリストです。

それぞれのエントリーは参照情報があるため短いです。
十分な情報と共に書かれた全ての変更のリストは ChangeLog ファイルか bugs.ruby-lang.org の issue を参照してください。

== 2.2.0 以降の変更

=== 言語仕様の変更

  * frozen-string-literal プラグマ:
    * 実験的な機能として fronzen-string-literal というプラグマが導入されました。
      [[url:https://bugs.ruby-lang.org/issues/8976]]
    * さらに --enable/--disable=frozen-string-literal というコマンドラインオプションも導入されました
      [[url:https://bugs.ruby-lang.org/issues/8976]]
    * コマンドラインオプションに --debug または --debug=frozen-string-literal を付けて実行すると、
      freeze された文字列を操作しようとして RuntimeError が発生したときにそのオブジェクトが生成された位置を表示します。
      [[url:https://bugs.ruby-lang.org/issues/11725]]

  * safe navigation operator (ぼっち演算子):
    * object&.foo という形式のメソッド呼び出し形式が追加されました。これは object が nil でないときにメソッド foo を呼び出します。
      Active Support の try! と似ていますが、メソッド名は文法的に必須であるという点が異なります。
      [[url:https://bugs.ruby-lang.org/issues/11537]]
//emlist{
          obj.try! {} # valid
          obj&. {}    # syntax error
//}
      * 引数はメソッドが呼び出された場合のみ評価されます。
//emlist{
          obj.try!(:foo, bar())  # bar() は常に評価されます
          obj&.foo(bar())        # bar() は条件付きで評価されます
//}
      * 属性値の代入にも使えます
//emlist{
          obj&.attr += 1
//}

  * did_you_mean gem:
    * 名前のタイポによって NameError や NoMethodError が起きたときに、自動的に他の似た名前を提案してくれます。
//emlist{
      "Yuki".starts_with?("Y")
      # => NoMethodError: undefined method `starts_with?' for "Yuki":String
      #    Did you mean?  start_with?
//}

  * インデントされたヒアドキュメント:
    * 新しい文字列リテラルとして <<~ で始まるヒアドキュメントが追加されました
      [[url:https://bugs.ruby-lang.org/issues/9098]]

=== 組み込みクラスの更新

  * [[c:ARGF]]
    * [[m:ARGF.read_nonblock]] は [[m:IO#read_nonblock]] と同じように `exception: false' オプションをサポートします
      [[url:https://bugs.ruby-lang.org/issues/11358]]

  * [[c:Array]]
    * [[m:Array#bsearch_index]] を追加
      [[url:https://bugs.ruby-lang.org/issues/10730]]
    * [[m:Array#dig]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11643]]

  * [[c:Comparable]]
    * [[m:Comparable#==]]はもはや例外を rescue しません
      [[url:https://bugs.ruby-lang.org/issues/7688]]

  * [[c:Encoding]]
    * [[m:Encoding::IBM037]] (alias ebcdic-cp-us; dummy) を追加

  * [[c:Enumerable]]
    * [[m:Enumerable#grep_v]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11049]]
    * [[m:Enumerable#chunk_while]]
      [[url:https://bugs.ruby-lang.org/issues/10769]]

  * [[c:Enumerator::Lazy]]
    * [[m:Enumerator::Lazy#grep_v]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11773]]

  * [[c:File]]
    * [[m:File.mkfifo]]
      [[url:https://bugs.ruby-lang.org/issues/11536]]
    * O_TMPFILE に対応する [[c:File::TMPFILE]] を追加

  * [[c:Hash]]
    * [[m:Hash#fetch_values]] を追加
      [[url:https://bugs.ruby-lang.org/issues/10017]]
    * [[m:Hash#dig]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11643]]
    * [[m:Hash#<=]], [[m:Hash#<]], [[m:Hash#>=]], [[m:Hash#>]] を追加
      [[url:https://bugs.ruby-lang.org/issues/10984]]
    * [[m:Hash#to_proc]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11653]]

  * [[c:IO]]
    * 新しいフラグ [[m:File::SHARE_DELETE]] が使用できます。
      Windows で開いているファイルを削除することを許可しますが、現在はファイルをバイナリモードで開いているときのみ効果があります。
      [[url:https://bugs.ruby-lang.org/issues/11218]]
    * `flags` オプションの追加。
      this parameter is bitwise-ORed to oflags generated by normal mode argument.
      [[url:https://bugs.ruby-lang.org/issues/11253]]
    * [[m:IO#advise]] はもはや Errno::ENOSYS を起こしません。
      サポートの有無を実行時ではなくビルド時に検出するためです。
      [[url:https://bugs.ruby-lang.org/issues/11806]]

  * [[c:Kernel]]
    * [[m:Kernel#loop]] は StopIteration で停止したときに nil ではなく最後に評価した要素を返します。
      [[url:https://bugs.ruby-lang.org/issues/11498]]

  * [[c:Module]]
    * [[m:Module#deprecate_constant]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11398]]

  * [[c:NameError]]
    * レシーバーオブジェクトを返す [[m:NameError#receiver]] を追加
      [[url:https://bugs.ruby-lang.org/issues/10881]]

  * [[c:Numeric]]
    * [[m:Numeric#positive?]], [[m:Numeric#negative?]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11151]]

  * [[c:Proc]]
    * [[m:Proc#call]] ( [[m:Proc#[] ]], [[m:Proc#===]], [[m:Proc#yield]]) は最適化されました。
      Backtrace doesn't show each method (show block lines directly).
      TracePoint also ignores these calls.
      [[url:https://bugs.ruby-lang.org/issues/11569]]

  * [[c:Queue]] ([[c:Thread::Queue]])
    * 終了を通知するために [[m:Queue#close]] を追加
      [[url:https://bugs.ruby-lang.org/issues/10600]]

  * [[c:Regexp]]/[[c:String]]: Unicode のバージョンを 7.0.0 から 8.0.0 に更新

  * [[c:RubyVM::InstructionSequence]]
    * 実験的な機能としてiseqローダー用の低レベルな操作をするメソッドをいくつか追加
      使用例は sample/iseq_loader.rb を見てください。
      ローダーには検証機能がないので、編集したバイナリや壊れたバイナリをロードすると簡単に致命的な問題を起こすことができます。
      [[url:https://bugs.ruby-lang.org/issues/11788]]
      * [[m:RubyVM::InstructionSequence#to_binary]](extra_data = nil)
      * [[m:RubyVM::InstructionSequence.load_from_binary]](binary)
      * [[m:RubyVM::InstructionSequence.load_from_binary_extra_data]](binary)

  * [[c:String]]
    * フリーズされていない文字列を生成する[[m:String#+@]] を追加
    * フリーズされた文字列を生成する [[m:String#-@]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11782]]
    * [[m:String.new]] に `encoding` オプションが追加されました
      [[url:https://bugs.ruby-lang.org/issues/11785]]

  * [[c:Struct]]
    * [[m:Struct#dig]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11688]]

  * [[c:Thread]]
    * スレッッド名を扱うために [[m:Thread#name]], [[m:Thread#name=]] を追加
      [[url:https://bugs.ruby-lang.org/issues/11251]]

=== 組み込みクラスの互換性 (機能追加とバグ修正を除く)

  * [[c:Array]]
    * [[m:Array#select!]], [[m:Array#keep_if]], [[m:Array#reject!]], [[m:Array#delete_if]]
      ブロックが評価される度にレシーバーの配列をすぐに変更しないようになりました。
      [[url:https://bugs.ruby-lang.org/issues/10714]]
    * [[m:Array#flatten]] と [[m:Array#flatten!]] は与えられたレベルを越えた要素には
      `#to_ary`を呼ばないようになりました。
      [[url:https://bugs.ruby-lang.org/issues/10748]]
    * [[m:Array#inspect]] はその要素の文字列が Encoding.default_external と
      互換性のないエンコーディングであっても例外が発生しなくなりました。
      [[url:https://bugs.ruby-lang.org/issues/11801]]

  * [[c:Enumerable]]
    * [[m:Enumerable#chunk]] と [[m:Enumerable#slice_before]] は初期状態を引数として受け取らなくなりました。
      状態の管理にはローカル変数を使ってください。
      [[url:https://bugs.ruby-lang.org/issues/10958]]

  * [[c:File::Stat]]
    * Windows では [[m:File::Stat#ino]] は常に 0 を返していましたが、
      BY_HANDLE_FILE_INFORMATION.nFileIndexHigh/Low を返すようになりました。
      [[url:https://bugs.ruby-lang.org/issues/11216]]

  * [[c:Hash]]
    * [[m:Hash#inspect]] はその要素の文字列が Encoding.default_external と
      互換性のないエンコーディングであっても例外が発生しなくなりました。
      [[url:https://bugs.ruby-lang.org/issues/11801]]

  * [[c:IO]]
    * クローズ済みのIOオブジェクトに [[m:IO#close]] を呼んでも例外が発生しなくなりました。
      [[url:https://bugs.ruby-lang.org/issues/10718]]
    * [[m:IO#each_codepoint]] は、変換時、EOFの前に不完全な文字があると例外が発生するようになりました。
      [[url:https://bugs.ruby-lang.org/issues/11444]]

  * [[c:Module]]
    * [[m:Module#define_method]] と [[m:Object.define_singleton_method]] は
      メソッド本体(Procオブジェクト、Methodオブジェクト、またはブロック )が必須になりました。
      ブロックが与えられない場合は ArgumentError が発生します。
      [[url:https://bugs.ruby-lang.org/issues/11283]]]

  * pack/unpack (Array/String)
    * `j`と`J`が追加されました。
      [[url:https://bugs.ruby-lang.org/issues/11215]]


=== 標準添付ライブラリの更新 (優れたもののみ)

  * [[c:Logger]]
    * [[m:Logger#level=]] はシンボルと文字列でログレベルを指定できるようになりました。(大文字・小文字を区別しません)
      [[url:https://bugs.ruby-lang.org/issues/11695]]
    * ログデバイスを開きなおすために [[m:Logger#reopen]] が追加されました。
      [[url:https://bugs.ruby-lang.org/issues/11696]]

  * [[lib:io/wait]]
    * [[m:IO#wait_readable]] は FIONREAD をチェックしなくなりました。
      ソケットのようなバイトストリームではないIOで使われます。

  * [[c:Net::FTP]]
    * [[m:Net::FTP#mlst]] を追加。
    * [[m:Net::FTP#mlsd]] を追加。

  * [[lib:nkf]]
    * nkf 2.1.4 をマージしました。

  * [[c:ObjectSpace]] ([[lib:objspace]])
    * [[m:ObjectSpace.count_symbols]] を追加。
    * [[m:ObjectSpace.count_imemo_objects]] を追加。
    * [[m:ObjectSpace.internal_class_of]] を追加。
    * [[m:ObjectSpace.internal_super_of]] を追加。

  * [[c:OpenSSL]]
    * [[m:OpenSSL::SSL::SSLSocket#accept_nonblock]] と
      [[m:OpenSSL::SSL::SSLSocket#connect_nonblock]] は `exception: false` オプションをサポートするようになりました。
      [[url:https://bugs.ruby-lang.org/issues/10532]]

  * [[c:Pathname]]
    * [[m:Pathname#descend]] と [[m:Pathname#ascend]] はブロックなしでの呼び出しができるようになりました。
      [[url:https://bugs.ruby-lang.org/issues/11052]]

  * [[c:Socket]]
    * [[m:Socket#connect_nonblock]], [[m:Socket#accept_nonblock]],
      [[m:TCPServer#accept_nonblock]], [[m:UNIXServer#accept_nonblock]],
      [[m:BasicSocket#recv_nonblock]], [[m:BasicSocket#recvmsg_nonblock]],
      [[m:BasicSocket#sendmsg_nonblock]] に `exception: false` オプションを追加しました。
      例外 [[c:IO::WaitReadable]] や [[c:IO::WaitWritable]] を発生させるかわりに :wait_readable, :wait_writable を返すためです。
      [[url:https://bugs.ruby-lang.org/issues/10532]]
      [[url:https://bugs.ruby-lang.org/issues/11229]]
    * [[m:BasicSocket#recv]] と [[m:BasicSocket#recv_nonblock]] は GC のオーバーヘッドを減らすために
      [[m:IO#read]] や [[m:IO#read_nonblock]] と同じように出力用の文字列を引数として受けとれるようになりました。
      [[url:https://bugs.ruby-lang.org/issues/11242]]

  * [[c:StringIO]]
    * リードオンリーモードでは、[[m:StringIO#set_encoding]] はそのバッファ文字列にエンコーディングをセットしないようになりました。
      [[m:StringIO#set_encoding]] を使わずに文字列のエンコーディングを設定すると予期しない動作の原因となるかもしれません。
      [[url:https://bugs.ruby-lang.org/issues/11827]]

  * [[lib:timeout]]
    * [[m:Object#timeout]]は呼び出すと非推奨として警告されるようになりました。

=== 標準添付ライブラリの互換性 (機能追加とバグ修正を除く)

  * ext/coverage/coverage.c
    * [[m:Coverage.peek_result]] を追加。カバレッジツールを停止することなくカバレッジに関する情報を取得することができます。
      [[url:https://bugs.ruby-lang.org/issues/10816]]

  * [[c:Fiddle]]
    * [[m:Fiddle::Function#call]] は GVL を解放するようになりました。
      [[url:https://bugs.ruby-lang.org/issues/11607]]

  * [[lib:io/console]]
    * io-console 0.4.5になりました。
      ライセンスが BSD 2-clause "Simplified" License に変更されました。

  * [[lib:base64]]
    * [[m:Base64.urlsafe_encode64]] に パディング文字("=")を抑制するために "padding" オプションが追加されました。
      [[url:https://bugs.ruby-lang.org/issues/10740]]
    * [[m:Base64.urlsafe_decode64]]: パディングされていない入力だけでなく正しくパディングされた入力も受け付けるようになりました。
      [[url:https://bugs.ruby-lang.org/issues/10740]]

  * [[lib:drb]]
    * 使用していない引数を削除しました。
      [[url:https://github.com/ruby/ruby/pull/515]]

  * [[lib:matrix]]
    * [[m:Vector#round]]を追加。
      [[url:https://github.com/ruby/ruby/pull/802]]

  * [[lib:webrick/utils]]
    * 使用していない引数を削除しました。
      [[url:https://github.com/ruby/ruby/pull/356]]

  * [[c:Net::FTP]]
    * パッシブモードでの接続がデフォルトになりました。
      [[m:Net::FTP.default_passive=]] で変更することができます。
      [[url:https://bugs.ruby-lang.org/issues/11612]]

  * [[c:Net::HTTP]]
    * [[m:Net::HTTP#open_timeout]] のデフォルト値が 60 になりました。(以前は nil でした)

  * [[c:Net::Telnet]]
    * [[c:Net::Telnet]] は net-telnet gem になりました。
      [[url:https://bugs.ruby-lang.org/issues/11083]]

  * [[lib:psych]]
    * Psych 2.0.17 に更新しました。

  * Rake
    * Rake は標準添付ライブラリから削除されて bundled gem になりました。
      [[url:https://bugs.ruby-lang.org/issues/11025]]

  * RDoc
    * RDoc 4.2.1 に更新しました。
      * [[url:https://github.com/rdoc/rdoc/blob/master/History.rdoc#421--2015-12-22]]

  * RubyGems
    * RubyGems 2.5.1 に更新しました。
      * [[url:http://docs.seattlerb.org/rubygems/History_txt.html#label-2.5.0+-2F+2015-11-03]]
      * [[url:http://docs.seattlerb.org/rubygems/History_txt.html#label-2.5.1+-2F+2015-12-10]]

=== 組込みのグローバル変数の互換性に影響のある変更

  * [[m:$SAFE]]
    * $SAFE=2 と $SAFE=3 廃止されました。$SAFE を2以上にすると ArgumentError が発生します。
      [[url:https://bugs.ruby-lang.org/issues/5455]]

=== C API の更新

  * rb_define_class_id_under() は既にクラスが定義済みなのに、
    そのスーパークラスが与えられたスーパークラスと一致しないとき
    Rubyレベルの定義と同じように TypeError を発生させるようになりました。

  * 現在日時を timespec 構造体として取得する rb_timespec_now() が追加されました。
    [[url:https://bugs.ruby-lang.org/issues/11558]]

  * rb_time_timespec_new() is added to create a time object with epoch,
    nanosecond, and UTC/localtime/time offset arguments.
    [[url:https://bugs.ruby-lang.org/issues/11558]]

  * rb_autoload() は非推奨になりました。rb_funcall() を使ってください。
    [[url:https://bugs.ruby-lang.org/issues/11664]]

  * rb_compile_error_with_enc(), rb_compile_error(), rb_compile_bug() が非推奨になりました。
    これらの関数は公開されていますが、内部利用のためなので外部のライブラリでは使用するべきではありません。

=== サポートしているプラットフォームの変更

  * OS/2 はもうサポートされていません。
  * BeOS はもうサポートされていません。
  * Borland-C はもうサポートされていません。
  * Haiku は安定しています。ベストエフォートです。

=== 実装の改善

  * [[m:Proc#call]] をメソッドフレームの構築を取り除いて最適化しました。
    [[url:https://bugs.ruby-lang.org/issues/11569]]

  * メソッドエントリのデータ構造を再考しました。
    [[url:https://bugs.ruby-lang.org/issues/11278]]

  * メソッドテーブルなどに使用する新しいテーブルデータ構造を導入しました。
    新しいテーブル構造は st_table よりもシンプルで速いです。
    [[url:https://bugs.ruby-lang.org/issues/11420]]

  * オブジェクトアロケーションとメソッド呼び出しのために機械語レベルのチューニングをしました。
    r52099, r52254

  * 将来の改善のために RubyVM::InstructionSequence が拡張されました。
    [[url:https://bugs.ruby-lang.org/issues/11788]]

  * nil, true, false の case 式のディスパッチが最適化されました。
    以前は文字列、シンボル、整数、浮動小数のみが最適化されていました。
    [[url:https://bugs.ruby-lang.org/issues/11769]]

  * ピュアRubyではないクラス(T_DATA, T_FILE など)上のインスタンス変数は以前よりも保存にコストがかからなくなりました。
    [[url:https://bugs.ruby-lang.org/issues/11170]]

  * 巨大な [[c:Struct]] のオブジェクトのメンバーへのアクセスが定数時間になりました。
    以前は、最初の10要素を越えると線形にスキャンしていました。
    [[url:https://bugs.ruby-lang.org/issues/10585]]

  * [[c:Set]] の速度は向上しました。
    [[url:https://bugs.ruby-lang.org/issues/10754]]
    [r52591]

  * Socket と I/O関連の改善
    * [[url:https://bugs.ruby-lang.org/issues/11229]] でI/Oのメソッドに導入された新しいキーワード引数によるオーバーヘッドは
      [[url:https://bugs.ruby-lang.org/issues/11339]] でC APIでの非効率なキーワード引数のパースを避けることによって削減されました。
    * 改善された例外なしのノンブロッキングI/Oによって標準添付ライブラリが更新されました。
      [[url:https://bugs.ruby-lang.org/issues/11229]]
      これによって、コストのかかる例外が減ったのでデバッグモード時のアウトプットが少なくなりました。
      [[url:https://bugs.ruby-lang.org/issues/11044]]
    * (Linuxのみ) 標準添付ライブラリ内で、一つのFDをselect(2)で待つ箇所がなくなりました。
      大きい番号のFDで遅くなり辛くなりました。
      [[url:https://bugs.ruby-lang.org/issues/11081]]
      [[url:https://bugs.ruby-lang.org/issues/11377]]

  * [[m:CGI.escapeHTML]] はC拡張で最適化されました。
    [[url:https://github.com/ruby/ruby/pull/1164]]
